! WHIZARD 1.24 Jan 31 2003
! 
! (C) 1999-2002 by Wolfgang Kilian <kilian@particle.uni-karlsruhe.de>
!
! WHIZARD is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2, or (at your option)
! any later version.
!
! WHIZARD is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! This file has been stripped of most comments.  For documentation, refer
! to the source 'whizard.nw'

module files

  use limits, only: DEFAULT_FILENAME, FILENAME_LEN

  implicit none
  private

  public :: choose_filename
  public :: concat
  public :: file_exists_else_default

  interface concat
     module procedure concat_two, concat_three
  end interface

contains

  function choose_filename (file, default_file) result (chosen_file)
    character(len=*), intent(in) :: file, default_file
    character(len=FILENAME_LEN) :: chosen_file
    if (len_trim (file) == 0) then
       chosen_file = default_file
    else
       chosen_file = file
    end if
  end function choose_filename

  function concat_two (prefix, filename, extension) result (file)
    character(len=*) :: prefix, filename, extension
    character(len=FILENAME_LEN) :: file
    file = trim(filename)//"."//trim(extension)
    if (prefix /= "" .and. filename(1:1) /= "/" .and. filename(1:2) /= "./") &
         & file = trim(prefix) // "/" // file
  end function concat_two

  function concat_three (prefix, filename, process_id, extension) result (file)
    character(len=*) :: prefix, filename, process_id, extension
    character(len=FILENAME_LEN) :: file
    file = trim(filename)//"."//trim(process_id)//"."//trim(extension)
    if (prefix /= "" .and. filename(1:1) /= "/" .and. filename(1:2) /= "./") &
         & file = trim(prefix) // "/" // file
  end function concat_three

  function file_exists_else_default (prefix, filename, extension) result (file)
    character(len=*) :: prefix, filename, extension
    character(len=FILENAME_LEN) :: file
    logical :: exist
    file = concat (prefix, filename, extension)
    inquire (file=trim(file), exist=exist)
    if (.not.exist) then
       file = concat (prefix, DEFAULT_FILENAME, extension)
       inquire (file=trim(file), exist=exist)
       if (.not.exist)  then
          file = ""
       end if
    end if
  end function file_exists_else_default


end module files
